# Copyright (C) 1993, 1994, 1995 John W. Eaton
# 
# This file is part of Octave.
# 
# Octave is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
# 
# Octave is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Octave; see the file COPYING.  If not, write to the Free
# Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Modified by Joao Cardoso on Oct 20, 1995. jcardoso@bart.inescn.pt
#
function mesh (x, y, z)

# usage: mesh (x, y, z)
#
# See also: plot, semilogx, semilogy, loglog, polar, meshdom, contour,
#           bar, stairs, gplot, gsplot, replot, xlabel, ylabel, title 

  if (nargin == 1)
    z = x;
    if (is_matrix (z))
warning("**** THIS SECTION NOT TESTED, watch next elseif, it is working ****")
     	gnu_i("set hidden3d; set data style lines; set surface");
	gnu_i("set nocontour; set noparametric; set view 60, 30, 1, 1");
	tmp_file = tmp_file_name;
	eval (sprintf("save %s z", tmp_file));
	gnu_i(sprintf("splot ""%s""", tmp_file));
    else
      error ("mesh: argument must be a matrix");
    endif
  elseif (nargin == 3)
    if (is_vector (x) && is_vector (y) && is_matrix (z))
      xlen = length (x);
      ylen = length (y);
      if (xlen == rows (z) && ylen == columns (z))
        if (rows (x) == 1)
          x = x';
        endif
#        len = 3 * ylen;
#        zz = zeros (xlen, ylen);
#        k = 1;
#        for i = 1:3:len
#          zz(:,i)   = x;
#          zz(:,i+1) = y(k) * ones (xlen, 1);
#          zz(:,i+2) = z(:,k);
#          k++;
#        endfor

# The next section could be faster if using Gnuplot binary format, as
# I think that octave's gsplot does, given the format of zz.

tmp_file = tmp_file_name;
fp = fopen(sprintf("%s",tmp_file),"w");
for i=1:xlen
	for j=1:xlen
		fprintf(fp,"%f %f %f\n",x(i),y(j),z(i,j));
	endfor
	fprintf(fp,"\n");
endfor
fclose(fp);

	gnu_i ("set hidden3d; set data style lines; set surface");
        gnu_i ("set nocontour; set parametric; set view 60, 30, 1, 1");
	gnu_i(sprintf("splot ""%s"" t ""line-1""", tmp_file));

      else
        msg = "mesh: rows (z) must be the same as length (x) and";
        msg = sprintf ("%s\ncolumns (z) must be the same as length (y)", msg);
        error (msg);
      endif
    else
      error ("mesh: x and y must be vectors and z must be a matrix");
    endif    
  else
    usage ("mesh (z)");
  endif

endfunction
